#!/usr/bin/env perl

use JSON;
use LWP;
use LWP::Simple;
use HTTP::Request::Common;

open($fh, "<login");
$inp = <$fh>;
$inp =~ s/\W//g;
$tok{client_id} = $inp;
$inp = <$fh>;
$inp =~ s/\W//g;
$tok{client_secret} = $inp;
close $fh;

$json = JSON->new->allow_nonref;

$tok{grant_type} = 'client_credentials';
$tok{action} = 'getToken';

$reqs = $json->encode(\%tok);
$res = doPost('https://api.hedgechatter.com/v1/token',  $reqs);
print "$res\n";
$s = $json->decode($res);
print "access token: $s->{data}{access_token} \n";
$tok = $s->{data}{access_token};


$ts = time;

`mkdir data`;
`mkdir data/getMarketDashboard`;

for($i=0;$i<2;$i++){
  $t = $ts - 86400*$i;
  @gmt = localtime($t);
  $ymd = sprintf("%d%02d%02d", $gmt[5]+1900, $gmt[4]+1, $gmt[3]);
  print "$ymd\n";

  $res = getMarketDashboard($ymd, $tok);
  open($fh, ">data/getMarketDashboard/$ymd");
  print $fh $res;
  close $fh;

  sleep(1);
  
}


$tok{action} = 'deleteToken';
$tok{client_id} = 'testclient';
$tok{client_secret} = 'testpass';

$reqs = $json->encode(\%tok);

$res = doPost('https://api.hedgechatter.com/v1/token',  $reqs);

print "$res\n";


sub doPostForm{
  my($url, %data) = @_;
  my($ua, $res);

  $ua = LWP::UserAgent->new;
  $res = $ua->post($url, 'Content_Type'=>'application/x-www-form-urlencoded', 'Content'=>\%data);
  return $res->content() . "\n";
}

sub doPost{
  my($url, $json) = @_;
  my($req, $ua, $res);

  my $req = HTTP::Request->new(POST => $url);
  $req->content_type('application/json');
  $req->content($json);
  my $ua = LWP::UserAgent->new; 
  my $res = $ua->request($req);
  return $res->content() . "\n";
}

sub getStockDashboard{
  my($sym, $tok) = @_;
  my(%req, $reqs, $res);

  $req{action} = 'getStockDashboard';
  $req{symbol} = $sym;
  $req{data} = ['chatter', 'price', 'volume', 'news', 'sentiment', 'manipulation'];
  $req{access_token} = $tok;
  $req{start} = '20130915';
  $req{end} = '20130916';

  $reqs = $json->encode(\%req);
  $res = doPost('https://api.hedgechatter.com/v1/',  $reqs);
  return $res;
}

sub getSentiment{
  my($sym, $tok) = @_;
  my(%req, $reqs, $res);

  $req{action} = 'getSentiment';
  $req{symbols} = [$sym];
  $req{data} = ['num', 'nsent', 'tsent', 'unum', 'unsent', 'utsent', 'sbuy', 'buy', 'hold', 'sell', 'ssell', 'usbuy', 'ubuy', 'uhold', 'usell', 'ussell'];
  $req{access_token} = $tok;
  $req{start} = '20130915';
  $req{end} = '20130916';

  $reqs = $json->encode(\%req);
  $res = doPost('https://api.hedgechatter.com/v1/',  $reqs);
  return $res;
}


sub getMarketDashboard{
  my($ymd, $tok) = @_;
  my(%req, $reqs, $res);

  $req{action} = 'getMarketDashboard';
  $req{date} = $ymd;
  $req{data} = ['chatterVolume', 'sentimentVolume', 'negativeSentiment', 'positiveSentiment', 'sentimentGainers', 'sentimentLosers', 'newsVolume', 'newsSpike', 'twitterVolume', 'twitterSpike', 'accurateAlerts'];
  $req{access_token} = $tok;
  $req{top} = '100';

  $reqs = $json->encode(\%req);
print "$reqs\n";
  $res = doPost('https://api.hedgechatter.com/v1/',  $reqs);
  return $res;
}



