#!/usr/bin/env perl

use JSON;
use LWP;
use LWP::Simple;
use HTTP::Request::Common;

open($fh, "<symbols.txt");
@syms = <$fh>;
close $fh;

$json = JSON->new->allow_nonref;

$tok{grant_type} = 'client_credentials';
$tok{action} = 'getToken';

open($fh, "<login");
$inp = <$fh>;
$inp =~ s/\W//g;
$tok{client_id} = $inp;
$inp = <$fh>;
$inp =~ s/\W//g;
$tok{client_secret} = $inp;
close $fh;

$reqs = $json->encode(\%tok);
$res = doPost('https://api.hedgechatter.com/v1/token',  $reqs);
print "$res\n";
$s = $json->decode($res);
print "access token: $s->{data}{access_token} \n";
$tok = $s->{data}{access_token};


`mkdir data`;
`mkdir data/getStockDashboard`;
`mkdir data/getSentiment`;

foreach $sym (@syms){
  chomp $sym;
  print "$sym\n";

  $res = getStockDashboard($sym, $tok);
  open($fh, ">data/getStockDashboard/$sym");
  print $fh $res;
  close $fh;
  sleep(1);
  
  $res = getSentiment($sym, $tok);
  open($fh, ">data/getSentiment/$sym");
  print $fh $res;
  close $fh;
  sleep(1);
}


$tok{action} = 'deleteToken';
$tok{client_id} = 'testclient';
$tok{client_secret} = 'testpass';

$reqs = $json->encode(\%tok);

$res = doPost('https://api.hedgechatter.com/v1/token',  $reqs);

print "$res\n";


sub doPost{
  my($url, $json) = @_;
  my($req, $ua, $res);

  my $req = HTTP::Request->new(POST => $url);
  $req->content_type('application/json');
  $req->content($json);
  my $ua = LWP::UserAgent->new; 
  my $res = $ua->request($req);
  return $res->content() . "\n";
}

sub getStockDashboard{
  my($sym, $tok) = @_;
  my(%req, $reqs, $res);

  $req{action} = 'getStockDashboard';
  $req{symbol} = $sym;
  $req{data} = ['chatter', 'price', 'volume', 'news', 'sentiment', 'manipulation'];
  $req{access_token} = $tok;
  $req{start} = '20130915';
  $req{end} = '20130916';

  $reqs = $json->encode(\%req);
  $res = doPost('https://api.hedgechatter.com/v1/',  $reqs);
  return $res;
}

sub getSentiment{
  my($sym, $tok) = @_;
  my(%req, $reqs, $res);

  $req{action} = 'getSentiment';
  $req{symbols} = [$sym];
  $req{data} = ['num', 'nsent', 'tsent', 'unum', 'unsent', 'utsent', 'sbuy', 'buy', 'hold', 'sell', 'ssell', 'usbuy', 'ubuy', 'uhold', 'usell', 'ussell'];
  $req{access_token} = $tok;
  $req{start} = '20130915';
  $req{end} = '20130916';

  $reqs = $json->encode(\%req);
  $res = doPost('https://api.hedgechatter.com/v1/',  $reqs);
  return $res;
}


